/*
 * BIG FAT WARNING:
 * this code based on "The Winamp Transcoder" plugin (http://www.srcf.ucam.org/~wdhf2/transcoder/)
 *
 * Copyright (c) 2005 Dmirty Alexandrov aka dimzon aka dimzon541 (dimzon541@gmail.com)
 * Copyright (c) 2004 Will Fisher (will.fisher@gmail.com)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

/*


********************************************************************
* AACPlus v2 Encoder (using WinAmp 5.1 enc_aacplus.dll)
* BIG FAT WARNING:
*	this code based on "The Winamp Transcoder" plugin
*	http://www.srcf.ucam.org/~wdhf2/transcoder/
* Source timestamp Fri Nov 18 13:22:23 2005
* Build Nov 18 2005, 13:25:23
********************************************************************
* NOTE!	enc_aacplus.dll must be into executable directory
*	get it from Winamp 5.1 plugins directory
********************************************************************
Usage:
	aacEncPlus.EXE <wav_file> <bitstream_file> [options]
Options:
	--cbr <bitrate>	- Set bitrate (CBR) to <bitrate> bps. Default is 64000
	--chmode <mode>	- integer between 1-5, default is 2
		1 - Mono
		2 - Stereo
		3 - Stereo Independent
		4 - Parametric (you MUST set use V2 encoder and <bitrate> can't exeed 48000)
		5 - Dual Channel
	--no-v2	- Use AACPlus v1 encoder instead v2
	--no-progress	- Disable progress display
	--mpeg4aac  - Produce MPEG4 AAC isntead of MPEG2 AAC (experimental!)
	--mp4box  - Wrap result into MPEG4 container (MP4BOX.EXE must be into executable directory)
	--rawpcm <rate> <cnt> <bp>	- Signal RAW PCM input intead of WAV
		<rate>	- Samplerate in Hz (32000, 44100 or 48000)
		<cnt>	- Channels count (1 or 2)
		<bp>	- Bit's per sample (8 or 16)
Example:
	aacEncPlus.EXE input.wav out.aac --cbr 56000
	aacEncPlus.EXE input.wav out.aac --cbr 48000 --chmode 4 --mpeg4aac
	aacEncPlus.EXE input.raw out.aac --mpeg4aac  --rawpcm 44100 2 16
	aacEncPlus.EXE input.wav out.m4a --cbr 32000 --chmode 4 --mpeg4aac --mp4box

WARNING: this encoder can read and encode data from stdin:
	use - as input filename
Example:
	aacEncPlus.EXE - out.aac --cbr 56000
	aacEncPlus.EXE - out.aac --cbr 48000 --chmode 4 --mpeg4aac
	aacEncPlus.EXE - out.aac --mpeg4aac  --rawpcm 44100 2 16
	aacEncPlus.EXE - out.m4a --cbr 32000 --chmode 4 --mpeg4aac --mp4box


*/

#include "stdafx.h"
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h>
#include <mmsystem.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>
#include <process.h>

// transcode() returns one of these:
#define TRANSCODE_FINISHED_OK        0
#define ERROR_CANNOT_LOAD_DECODER   -1
#define ERROR_CANNOT_OPEN_DECODER   -2
#define ERROR_CANNOT_LOAD_ENCODER   -3
#define ERROR_CANNOT_OPEN_ENCODER   -4
#define ERROR_INCOMPATABLE_DECODER  -5
#define ERROR_CANNOT_OPEN_OUTFILE   -6
#define ERROR_CANNOT_OPEN_INFILE    -7
#define ERROR_ABORTED               -8
// the main function may also return
#define ERROR_INSUFFICIENT_ARGS     -9

#define BUFSIZE 32768

class AudioCoder 
{
  public:
    AudioCoder() { }
    virtual int Encode(int framepos, void *in, int in_avail, int *in_used, void *out, int out_avail)=0; //returns bytes in out
    virtual ~AudioCoder() { };
};

typedef struct wavHeader {
  unsigned int chunkid;
  int totdatasize;
  unsigned int rifftype;
  unsigned int fmt;
  int fmtsize;
  unsigned short ccode;
  short nch;
  int srate;
  int bytespersec;
  short blockalign;
  short bps;
  unsigned int data;
  unsigned int datasize;
} wavHeader;

int _encode(FILE * hFile, AudioCoder * encoder,  int len, char * buf, int bMPEG4AAC)
{
	static char outbuffer[BUFSIZE];
	DWORD dwBytesWritten=0;
	int i=0;  
	for(;;) 
	{
		int in_used=0;
		//if(!len) break; - we must finalize it !
		int enclen=encoder->Encode(i++,buf,len,&in_used,outbuffer,sizeof(outbuffer));

		if(enclen>0) 
		{
			//if(bMPEG4AAC) outbuffer[1] &= 0xf7;
			fwrite(outbuffer, 1, enclen, hFile);
		}

		if(in_used>0) 
		{
			buf += in_used;
			len -= in_used;
		}

		if(((in_used <=0) && (enclen <=0)) || (0==len)) // Detect unbreakable loop
			break;
	}
	return 0;
}

void showLogo()
{
	printf("********************************************************************\n* AACPlus v2 Encoder (using Winamp 5.2 enc_aacplus.dll)\n* Source timestamp %s\n* Build %s, %s\n********************************************************************\n* NOTE!	enc_aacplus.dll must be into executable directory\n*	get it from Winamp 5.2 plugins directory\n*	tested on Winamp 5.2 Release Feb 23 2006 Full (Not Pro) version)\n********************************************************************\n",
		__TIMESTAMP__, __DATE__, __TIME__);

}

void showUsage(char* exeName)
{
	char exeName2[MAX_PATH];
	_splitpath(exeName, NULL, NULL, exeName2, NULL);
	showLogo();
	printf("Usage:\n\t%s <wav_file> <bitstream_file> [options]\n", exeName2);
	printf("Options:\n");
	printf("\t--cbr  <bitrate> - Set bitrate (CBR) to <bitrate> bps. Default is 48000\n");
	printf("\t--nops  - Disable Parametric Stereo\n");
	printf("\t--is  - Prefer Independed Stereo\n");
	printf("\t--dc  - Prefer Dual Channels\n");
	printf("\t--mpeg2aac  - Produce MPEG2 AAC isntead of MPEG4 AAC\n");
	printf("\t--lc  - Encode LC-AAC instead AAC+ (bitrate up to 320000)\n");
	printf("\t--high  - use aacPlusHigh Encoder (bitrate up to 256000, multichannel is not supported)\n");
	printf("\t--mp4box  - Wrap result into MPEG4 container (MP4BOX.EXE must be into executable directory)\n");
	printf("\t--rawpcm <rate> <cnt> <bp>	- Signal RAW PCM input intead of WAV\n");
	printf("\t\t<rate>	- Samplerate in Hz (32000, 44100 or 48000)\n");
	printf("\t\t<cnt>	- Channels count (1 or 2)\n");
	printf("\t\t<bp>	- Bit's per sample (8 or 16)\n");
	printf("WARNING: this encoder can read and encode data from stdin:\n\tuse - as input filename\n");
}

int main(int argc, char* argv[])
{
	int nChannelCount;
	int nSampleRate;
	int nBitrate=48000;
	int nBitsPerSample=16;
	int nChannelMode=2;
	int bMPEG4AAC=1;
	int bMP4BOX=0;
	int bNoPS = 0;
	int bRawPCM = 0;
	int nType=0; //(0- he, 1 - lc, 2 - he-high)
	DWORD dwBytesRead;
    char szTempName[MAX_PATH];
    char lpPathBuffer[BUFSIZE];

	char * strOutputFileName = NULL;
	char * strInputFileName = NULL;
	FILE*  hInput=NULL;
	FILE*	hOutput=NULL;
	wavHeader wav;

	if(argc<2) 
	{
		showUsage(argv[0]);
		return ERROR_INSUFFICIENT_ARGS;
	}

	strInputFileName	= argv[1];
	strOutputFileName	= argv[2];

	// let's parse command line
	for(int i=3;i<argc;++i)
	{
		if(0==strcmp("--rawpcm", argv[i]))
		{
			nSampleRate=atoi(argv[++i]);
			nChannelCount=atoi(argv[++i]);
			nBitsPerSample=atoi(argv[++i]);
			bRawPCM=1;
			continue;
		}

		if(0==strcmp("--nops", argv[i]))
		{
			bNoPS=1;
			continue;
		}
		if(0==strcmp("--is", argv[i]))
		{
			nChannelMode=3;
			continue;
		}
		if(0==strcmp("--dc", argv[i]))
		{
			nChannelMode=5;
			continue;
		}
		if(0==strcmp("--lc", argv[i]))
		{
			nType=1;
			continue;
		}
		if(0==strcmp("--high", argv[i]))
		{
			nType=2;
			continue;
		}
		if(0==strcmp("--cbr", argv[i]))
		{
			nBitrate=atoi(argv[++i]);
			continue;
		}
		if(0==strcmp("--mpeg2aac", argv[i]))
		{
			bMPEG4AAC=0;
			continue;
		}
		if(0==strcmp("--mp4box", argv[i]))
		{
			bMP4BOX=1;
			continue;
		}
	}

	showLogo();

	int bStdIn = 0==strcmp("-", strInputFileName)?1:0;
	// let's open WAV file
	if(bStdIn)
	{
		#ifdef WIN32
		setmode(fileno(stdin), O_BINARY);
		#endif
		hInput = stdin;
	}
	else
	{
		hInput = fopen(strInputFileName,"rb");
	}

	if(!hInput)
	{
		printf("Can't open input file!\n");
		return ERROR_CANNOT_OPEN_INFILE;
	};

	if(0==bRawPCM)
	{
		// let's read WAV HEADER
		memset(&wav, 0, sizeof(wav));
		if(fread(&wav, 1, sizeof(wav), hInput)!=sizeof(wav))
		{
			// Can't read wav header
			fclose(hInput);
			printf("Input file must be WAV PCM!\n");
			return ERROR_CANNOT_LOAD_DECODER;
		}

		if(	wav.chunkid!=0x46464952
			|| wav.rifftype!=0x45564157
			|| wav.fmt!=0x20746D66
			|| wav.fmtsize!=0x00000010
			|| wav.bps!=16
			|| (wav.srate!=32000 && wav.srate!=44100 && wav.srate!=48000 )
			|| wav.ccode!=0x0001)
		{
			// unsupported or invalid wav format
			fclose(hInput);
			printf("Invalid or unsuppored WAV file format (must be 16 bit PCM)\n");
			return ERROR_INCOMPATABLE_DECODER;
		}

		nBitsPerSample	= wav.bps;
		nChannelCount	= wav.nch;
		nSampleRate		= wav.srate;
	}


	int bitrates[3][6] = 
	{

		{
		 //he - mono,	 stereo,			6ch
		8000, 64000,	16000, 128000,	96000, 213335
		},
		{
		 //lc - mono,	 stereo,			6ch
		8000, 160000,	16000, 320000,	160000, 320000
		},
		{
		 //hi - mono,	 stereo,			6ch
		8000, 160000,	96000, 256000,	8000, 256000
		}


	};

	int maxBitrate=0;
	int minBitrate=0;

	switch(nChannelCount)
	{
		case 1:
			minBitrate = bitrates[nType][0];
			maxBitrate = bitrates[nType][1];
			break;
		case 2:
			minBitrate = bitrates[nType][2];
			maxBitrate = bitrates[nType][3];
			break;
		default:
			minBitrate = bitrates[nType][4];
			maxBitrate = bitrates[nType][5];
			break;
	}


	const char* channelModes[] = {"Multichannel", "Mono", "Stereo", "Independant Stereo", "Parametric Stereo", "Dual Channels"};


	const char* codecName[] = {"aacPlus v2 (HE-AAC+PS)","AAC-LC","aacPlusHigh"};

	nBitrate		= min(max(minBitrate, nBitrate), maxBitrate);
	nChannelMode	= 1==nChannelCount?1:((2==nChannelCount)?(	(nBitrate<=48000 && 0==nType && 0==bNoPS ) ?4:nChannelMode):0);

	// let's write used config:
	printf("Input file: %s\nOutput file: %s\nSampleRate: %d\nChannelCount: %d\nBitsPerSample: %d\nBitrate: %d\nChannelMode: %s\nEncoder: %s\n",
		strInputFileName, strOutputFileName, nSampleRate, nChannelCount,nBitsPerSample , nBitrate, channelModes[nChannelMode], codecName[nType]);



	
	//create temp file name	
	//GetTempPath()
	memset(lpPathBuffer,0,sizeof(lpPathBuffer));
	memset(szTempName,0,sizeof(szTempName));
    GetTempPath(
		sizeof(lpPathBuffer)/4,   // length of the buffer
        lpPathBuffer);      // buffer for path 

    GetTempFileName(lpPathBuffer, // directory for temp files 
        NULL,                    // temp file name prefix 
        0,                        // create unique name 
        szTempName);              // buffer for name 

	AudioCoder * encoder=NULL;
	AudioCoder *(*finishAudio3)(char *fn, AudioCoder *c)=NULL;
	void (*prepareToFinish)(const char *filename, AudioCoder *coder)=NULL;
	AudioCoder* (*createAudio3)(int nch, int srate, int bps, unsigned int srct, unsigned int *outt, char *configfile)=NULL;
	HMODULE encplug = LoadLibrary("enc_aacplus.dll");
	if(NULL == encplug)
	{
		fclose(hInput);
		printf("Can't find enc_aacplus.dll!\n");
		return ERROR_CANNOT_LOAD_ENCODER;
	}
	*(void **)&createAudio3 = (void *)GetProcAddress(encplug, "CreateAudio3");
	if( NULL == createAudio3)
	{
		FreeLibrary(encplug);
		fclose(hInput);
		printf("Can't find CreateAudio3 in enc_aacplus.dll!\n");
		return ERROR_CANNOT_LOAD_DECODER;
	}
	*(void **)&finishAudio3=(void *)GetProcAddress(encplug,"FinishAudio3");
	*(void **)&prepareToFinish=(void *)GetProcAddress(encplug,"PrepareToFinish");

	{
		const char* codecSection[] = {"audio_aacplus","audio_aac","audio_aacplushigh"};
		FILE * tmp = fopen(szTempName,"wt");
		fprintf(tmp, "[%s]\nsamplerate=%i\nchannelmode=%i\nbitrate=%i\nv2enable=1\nbitstream=%i\nsignallingmode=0\n", codecSection[nType] , nSampleRate, nChannelMode, nBitrate, bMPEG4AAC?5:0);
		fclose(tmp);
		const unsigned int codecFourCC[] = {mmioFOURCC('A','A','C','P'), mmioFOURCC('A','A','C','r'), mmioFOURCC('A','A','C','H')};
		unsigned int outt= codecFourCC[nType];
		encoder=createAudio3(nChannelCount,nSampleRate, nBitsPerSample ,mmioFOURCC('P','C','M',' '),&outt,szTempName);
		DeleteFile(szTempName);

		/*
		const char* codecSection[] = {"audio_aacplus","audio_aac","audio_aacplushigh"};
		FILE * tmp = fopen(szTempName,"wt");
		fprintf(tmp, "[audio_mp4_aacplus]\nsamplerate=%i\nchannelmode=%i\nbitrate=%i\nv2enable=1\nbitstream=%i\nsignallingmode=1\n", nSampleRate, nChannelMode, nBitrate, 4);
		fclose(tmp);
		const unsigned int codecFourCC[] = {mmioFOURCC('A','A','C','P'), mmioFOURCC('A','A','C','r'), mmioFOURCC('A','A','C','H')};
		unsigned int outt= mmioFOURCC('M','4','A','+');
		encoder=createAudio3(nChannelCount,nSampleRate,16,mmioFOURCC('P','C','M',' '),&outt,szTempName);
		DeleteFile(szTempName);
		*/
	}

	strcat(szTempName,".aac");


	if(NULL==encoder)
	{
		FreeLibrary(encplug);
		fclose(hInput);
		printf("Can't create encoder!\n");
		return ERROR_CANNOT_OPEN_ENCODER;
	}

	hOutput = fopen(bMP4BOX?szTempName:strOutputFileName, "wb");

	if (!hOutput) 
    { 
		delete encoder;
		FreeLibrary(encplug);
		fclose(hInput);
		printf("Can't create output file!\n");
        return ERROR_CANNOT_OPEN_OUTFILE;
    } 

	//	FILE * t = fopen("c:\\!.txt", "wt");


	// encode
	printf("Encoding...");
	int toRead = (2*nChannelCount*2*1024); // sizeof(lpPathBuffer)
	toRead = (sizeof(lpPathBuffer)/toRead)*toRead;
	while(0!=(dwBytesRead = fread(lpPathBuffer, 1, toRead, hInput)))
    {
		//FILE * t = fopen("c:\\!.txt", "wt");
		//fprintf(t, "%d %d", dwBytesRead, toRead);
		//fclose(t);
		_encode(hOutput, encoder, dwBytesRead, lpPathBuffer, bMPEG4AAC);
    } 
	printf("\rFinalizing...");

	// finalize encoding


	//if(prepareToFinish) prepareToFinish("",encoder);
	if(prepareToFinish) prepareToFinish(strOutputFileName,encoder);
	_encode(hOutput, encoder, 0, lpPathBuffer, bMPEG4AAC);
	//if (finishAudio3) finishAudio3("",encoder);
	if (finishAudio3) finishAudio3(strOutputFileName,encoder);
	fclose(hOutput);
	fclose(hInput);
	delete encoder;
	FreeLibrary(encplug);

	// shut down
	if(bMP4BOX)
	{
		printf("\rCreating MP4...");
		char strMP4BOX [MAX_PATH*2];
		GetModuleFileName(NULL, lpPathBuffer, MAX_PATH*2);
		GetShortPathName(lpPathBuffer,strMP4BOX, sizeof(strMP4BOX));
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		_splitpath( strMP4BOX, drive, dir, NULL, NULL );
		_makepath( strMP4BOX, drive, dir, "mp4box", "exe");
		sprintf(lpPathBuffer, "\"%s\"", strOutputFileName);
		
		int n;
		if(1!=nType)
			n = _spawnl(_P_WAIT, strMP4BOX, "-new", "-add", szTempName, "-sbr", lpPathBuffer, NULL);
		else
			n = _spawnl(_P_WAIT, strMP4BOX, "-new", "-add", szTempName, lpPathBuffer, NULL);

		DeleteFile(szTempName);
//		fprintf( t, "%d\n%s -new -add %s -sbr %s", n, strMP4BOX, szTempName, lpPathBuffer );
//		fclose(t);
		if(n!=0) 
			printf("Can't create MP4!\n");
		else
			printf("\rDone           \n");
		return n;
	}
	printf("\rDone           \n");
//		fclose(t);
	return TRANSCODE_FINISHED_OK;
}